/*************************

Faredio 2.0 Program "datasystem.js"
̃t@ĆAFaredio 2.0̃VXe\K{t@CłB
ҏWȂłB
Copyright(C) tamantrain

*************************/

//ϐ`(1)
var MAXSTACT = 100;	//1Hɍőݒułw
var MAXFIND = 50;	//search֐oH
var MAXLINE = 5;	//̌oHɂH܂ŋe邩
var DEFAULTCOLOR = "#9b9b9b";	//̃CJ[
var ERR = -1;	//G[萔

/***************************************/

//1wɊւNX: Station(w, [}\L, wioO)
Station = function(_name, _roman, _numberling) {
	this.name = _name;
	this.roman = _roman;
	this.numberling = _numberling;
}

/***************************************/

//wSĂǗNX: StationList
StationList = function() {
	this.staList = new Array();
}
//wXgɉwǉ郁\bh: addToStaList(Station^)
StationList.prototype.addToStaList = function(_station) {
	this.staList.push(_station);
}

//wwԍĕԂ֐
StationList.prototype.searchFromName = function(_name) {
	var maxCnt = this.staList.length;
	var result = ERR;

	for (var i=0; i<maxCnt; i++) {
		if (this.staList[i].name == _name) {
			result = i; break;
		}
	}

	return result;
}

//[}\LwԍĕԂ֐
StationList.prototype.searchFromRoman = function(_roman) {
	var maxCnt = this.staList.length;
	var result = ERR;

	for (var i=0; i<maxCnt; i++) {
		if (this.staList[i].roman == _roman) {
			result = i; break;
		}
	}

	return result;
}

//wioOwԍĕԂ֐
StationList.prototype.searchFromNumberling = function(_numberling) {
	var maxCnt = this.staList.length;
	var result = ERR;

	for (var i=0; i<maxCnt; i++) {
		if (this.staList[i].numberling == _numberling) {
			result = i; break;
		}
	}

	return result;
}

/***************************************/
//芷֎~̋K
//_staNum: wԍ
//_lineNum: 芷̘H

BanTransfer = function(_staNum, _lineNum) {
	this.staNum = _staNum;
	this.lineNum = _lineNum;
}

/***************************************/

//HɊւNX: Line
Line = function(_name, _fareRule, _walk, _color) {
	this.name = _name;
	this.staNum = new Array();	//ݒuwԍ̑Ή\
	this.roadK = new Array();	//iԖڂ(i+1)Ԗڂ܂ł̉wԃL
	this.fareRule = _fareRule;	//Kp^K̔ԍ
	this.walk = false;
	if (_walk!=undefined) this.walk = _walk;	//kAȂtrue
	this.banUse = new Array();	//~֎~w
	this.banTrans = new Array();	//芷֎~w
	this.color = DEFAULTCOLOR;
	if (_color != undefined) this.color = _color;	//HJ[
}

Line.prototype.setSta = function(_staNum, _roadK) {
	for (var i=0; i<_staNum.length; i++) {
		this.staNum[i] = _staNum[i];
		if (i<_roadK.length) this.roadK[i] = _roadK[i];
	}
}

//̘Hɂ̉w邩ǂ𔻒肵A΂̘HɂwԍAȂ΃G[lŕԂ\bh
Line.prototype.exsist = function(_staNum) {
	var result = ERR;

	for (var i=0; i<this.staNum.length; i++) {
		if (this.staNum[i] == _staNum) { result = i; break; }
	}

	return result;
}

//H̓wԂ̃LԂ\bh
//sta1, sta2͉wԍŎwFwƂ̘Hɂ邱ƂO
Line.prototype.distance = function(sta1, sta2) {
	var sta1IL = this.exsist(sta1);
	var sta2IL = this.exsist(sta2);
	var sta12buf = 0;
	var killo = 0;

	if (sta1IL > sta2IL) {
		sta12buf = sta2IL;
		sta2IL = sta1IL;
		sta1IL = sta12buf;
	}

	for (var i=sta1IL; i<sta2IL; i++) {
		killo += this.roadK[i];
	}

	return killo;
}

//芷֎~w̎w
Line.prototype.addBanTrans = function(_staNum, _lineNum) {
	this.banTrans.push(new BanTransfer(_staNum, _lineNum));
}

//̉w~֎~wǂ𔻒
Line.prototype.banUseSta = function(_staNumOnLine) {
	var result = false;

	for (var i=0; i<this.banUse.length; i++) {
		if (this.banUse[i]==this.staNum[_staNumOnLine]) { result = true; break; }
	}

	return result;
}

//芷֎~ǂ𔻒
Line.prototype.banTransSta = function(_staNumOnLine, _lineNum) {
	var result = false;

	//~֎~w̏ꍇ芷֎~wƔ
	result = this.banUseSta(_staNumOnLine);

	if (!result) for (var i=0; i<this.banTrans.length; i++) {
		if (this.banTrans[i].staNum==this.staNum[_staNumOnLine] && this.banTrans[i].lineNum==_lineNum) {
			result = true; break;
		}
	}

	return result;
}

/***************************************/

//^ڂ11: FareRow(^ICJ[h̉^Ŏw)
FareRow = function(_minK, _maxK, _fare) {
	this.minK = _minK;
	this.maxK = _maxK;
	this.fare = _fare;
}

//Ղ̎̉^擾郁\bh
FareRow.prototype.getTicketFare = function(_ICmode) {
	//_ICmode
	//0: Ղ̏ꍇICJ[h̉^̉~Pʐ؂̂
	//1: Ղ̏ꍇICJ[h̉^̉~Pʐ؂グ
	//2: Ղ̏ꍇICJ[h̉^̉~Pʎľܓ
	//ȊO: ՂICJ[h̉^͓

	var baseFare = this.fare;	//̉^(ICl)
	var adultFare = baseFare;	//Ղ̑l^

	switch (_ICmode) {
	  case 0: adultFare = 10*Math.floor(baseFare*0.1); break;
	  case 1: adultFare = 10*Math.ceil(baseFare*0.1); break;
	  case 2: adultFare = 10*Math.round(baseFare*0.1); break;
	}

	return adultFare;
}

/***************************************/

//^K߂NX: FareTable
FareTable = function(_ICmode) {
	this.fareRows = new Array();
	this.ICmode = _ICmode;
}

FareTable.prototype.addFareTable = function(_minK, _maxK, _fare) {
	var fareRowBuf = new FareRow(_minK, _maxK, _fare);
	this.fareRows.push(fareRowBuf);
}
//e[uIC^Ԃ\bh
FareTable.prototype.findFareIC = function(_killo) {
	var foundFare = 0;

	for (var i=0; i<this.fareRows.length; i++) {
		if ((this.fareRows[i].minK-1)<_killo && _killo<=this.fareRows[i].maxK) {
			foundFare = this.fareRows[i].fare;
			break;
		}
	}

	return foundFare;
}

//e[uԌ̉^Ԃ\bh
FareTable.prototype.findFareTicket = function(_killo) {
	var foundFare = 0;

	for (var i=0; i<this.fareRows.length; i++) {
		if ((this.fareRows[i].minK-1)<_killo && _killo<=this.fareRows[i].maxK) {
			foundFare = this.fareRows[i].getTicketFare(this.ICmode);
			break;
		}
	}

	return foundFare;
}

/***************************************/

//^̃e[u

SpcFare = function(_fareIC, _fareTicket, _via) {
	//this.sta1 = _sta1;
	//this.sta2 = _sta2;
	this.fareIC = _fareIC;
	this.fareTicket = _fareTicket;
	this.via = _via;
}

/***************************************/

//ϐ`(2)

var stationList = new StationList();
var lines = new Array();
var fareRule = new Array();	//W̉^K
var dataName = "";		//f[^̖O(SЖȂ)
var dataFileName = "";	//f[^t@C
var specificFare = new Array();	//^
var userCalc ="";		//[U[wXNvg̃t@C

/***************************************/

//kAo^NX
//staGrp: ݂ɓkA\ȉwԍ(array as integer)
//RXgN^ɂ莩ŐVHo^
WalkTransfer = function(_staGrp) {
	for (var i=0; i<_staGrp.length; i++)
	 for (var j=i+1; j<_staGrp.length; j++) {
		var walkRoute = new Line("kA",ERR,true);
		var d = new Array(1);
		d[0]=0;
		walkRoute.setSta(new Array(_staGrp[i], _staGrp[j]), d);
		lines.push(walkRoute);
	}
}